"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Es2_service_1 = require("./Es2.service");
var Es_service_1 = require("./Es.service");
var fs_1 = __importDefault(require("fs"));
var Output_service_1 = require("./Output.service");
var filepath = require('filepath');
var ActionService = /** @class */ (function () {
    function ActionService() {
        this.current_action = "";
    }
    ActionService.prototype.setOption = function (options) {
        this.current_options = options;
    };
    ActionService.prototype.setAction = function (action) {
        this.current_action = action;
    };
    ActionService.prototype.initEsService = function () {
        if (this.current_action != "init") {
            if (this.current_options.isAws) {
                this.es = new Es2_service_1.EsService(this.current_options);
            }
            else {
                this.es = new Es_service_1.EsService(this.current_options);
            }
        }
    };
    ActionService.prototype.doCurrentAction = function () {
        if ("" == this.current_action) {
            Output_service_1.outPut.warn("Missing a valid action. Input \'esbs -h\' to show help ");
            return false;
        }
        switch (this.current_action) {
            case "backup":
                this.setBackupAction();
                break;
            case "restore":
                this.setRestoreAction();
                break;
            case "delete":
                this.setDeleteAction();
                break;
            case "init":
                this.initEnv();
                break;
            case "showTasks":
                this.setShowTaskListAction();
                break;
            case "showRepository":
                this.setShowRepositoryListAction();
                break;
            case "showSnapshot":
                this.setShowSnapshotListAction();
                break;
            case "showSnapshotInfo":
                this.setShowSnapshotStatusAction();
                break;
            case "createRepository":
                this.createRepositoryAction();
                break;
            case "showRecovery":
                this.setShowRecoveryAction();
                break;
            case "showSnapshotStatus":
                this.setShowSnapshotStatusAction();
                break;
            default:
                break;
        }
    };
    ActionService.prototype.initEnv = function () {
        var home = filepath.home();
        var config_file = home.path + '/.esbs_config';
        var source_file = __dirname + '/../../.esbs_config_bak';
        fs_1.default.copyFile(source_file, config_file, function (err) {
            if (err)
                throw err;
            Output_service_1.outPut.success("Config file .esbs_config was copied to '" + home.path + "'");
        });
    };
    ActionService.prototype.getCrẹateRepositoryOption = function () {
        var option = {
            repository: this.current_options.repository,
            type: this.current_options.type,
            location: this.current_options.location
        };
        return option;
    };
    ActionService.prototype.getCreateSnapshotOption = function () {
        var option = {
            repository: this.current_options.repository,
            snapshot: this.current_options.snapshot,
            waitForCompletion: this.current_options.waitForCompletion,
            indices: this.current_options.indices
        };
        return option;
    };
    ActionService.prototype.createRepositoryAction = function () {
        this.es.createRepository(this.current_options);
    };
    ActionService.prototype.setBackupAction = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.es.createRepository(this.current_options)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.es.createSnapshot(this.current_options).then(function () {
                                _this.es.showSnapshotStatus(_this.current_options).then(function () {
                                    _this.es.showSnapshotStatusWatching(_this.current_options);
                                });
                            }).catch(function (error) {
                                Output_service_1.outPut.error(error.toString());
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ActionService.prototype.setDeleteAction = function () {
        if (!this.current_options.repository) {
            Output_service_1.outPut.error("A Repository is required");
            return false;
        }
        if (!this.current_options.snapshot) {
            this.es.deleteRepository({ repository: this.current_options.repository });
        }
        else {
            var _option = {
                repository: this.current_options.repository,
                snapshot: this.current_options.snapshot
            };
            this.es.deleteSnapshot(_option);
        }
    };
    ActionService.prototype.setRestoreAction = function () {
        var _this = this;
        if (!this.current_options.repository) {
            Output_service_1.outPut.error("A Repository is required");
            return false;
        }
        if (!this.current_options.snapshot) {
            Output_service_1.outPut.error("A Snapshot is required");
            return false;
        }
        this.es.restore(this.current_options).then(function (resp) {
            console.log(resp);
            if (resp.status != "successed") {
                return false;
            }
            var _option = { indices: _this.current_options.rename_replacement };
            _this.setIndicisBySnapshotInfo();
            _this.es.showRecoveryWatching(_option);
        });
    };
    ActionService.prototype.setShowTaskListAction = function () {
        this.es.showTaskListSimple();
    };
    ActionService.prototype.setShowRepositoryListAction = function () {
        this.es.showRepository();
    };
    ActionService.prototype.setShowSnapshotListAction = function () {
        if (!this.current_options.repository) {
            Output_service_1.outPut.error("A Repository is required");
            return false;
        }
        this.es.showSnapshot({
            repository: this.current_options.repository
        });
    };
    ActionService.prototype.setShowSnapshotInfoAction = function () {
        if (!this.current_options.repository) {
            Output_service_1.outPut.error("A Repository is required");
            return false;
        }
        if (!this.current_options.snapshot) {
            Output_service_1.outPut.error("A Snapshot is required");
            return false;
        }
        this.es.showSnapshotInfo({
            repository: this.current_options.repository,
            snapshot: this.current_options.snapshot
        });
    };
    ActionService.prototype.setShowSnapshotStatusAction = function () {
        var _option = {
            repository: this.current_options.repository,
            snapshot: this.current_options.snapshot
        };
        if (this.current_options.watch) {
            this.es.showSnapshotStatusWatching(_option);
        }
        else {
            this.es.showSnapshotStatus(_option);
        }
    };
    ActionService.prototype.setIndicisBySnapshotInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.es.setIndicisBySnapshotInfo(this.current_options)
                            .then(function (resp) {
                            resp = _this.es.respFormat(resp);
                            try {
                                _this.current_options.indices = resp.snapshots[0].indices.join(",");
                            }
                            catch (error) {
                            }
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ActionService.prototype.setShowRecoveryAction = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.current_options.repository && this.current_options.snapshot)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setIndicisBySnapshotInfo()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (this.current_options.watch) {
                            this.es.showRecoveryWatching(this.current_options);
                        }
                        else {
                            this.es.showRecovery(this.current_options);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return ActionService;
}());
var actionService = new ActionService();
exports.actionService = actionService;
