"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Output_service_1 = require("./Output.service");
var sleep = require("sleep");
var clc = require("cli-color");
var EsServiceBase = /** @class */ (function () {
    function EsServiceBase() {
        this.host = process.env.ES_HOST;
        this.port = process.env.ES_PORT;
        this.storage_path = process.env.STORAGE_PATH;
        this.watch_stop = false;
        this.tmp_status = "";
        this.temporay_repository = "";
    }
    EsServiceBase.prototype.respFormat = function (resp) {
        return resp;
    };
    EsServiceBase.prototype.createRepository = function (option) {
        return __awaiter(this, void 0, void 0, function () {
            var parmaters, resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        parmaters = {};
                        switch (option.type) {
                            case 'fs':
                                parmaters = {
                                    "type": option.type,
                                    "settings": {
                                        "location": option.location
                                    }
                                };
                                break;
                            case 's3':
                                parmaters = {
                                    "type": option.type,
                                    "settings": {
                                        "bucket": option.S3_BUCKET,
                                        "base_path": option.repository
                                    }
                                };
                                if (option.isAws) {
                                    parmaters.settings.region = option.AWS_REGION;
                                    parmaters.settings.endpoint = "";
                                    parmaters.settings.role_arn = option.role_arn;
                                }
                                else {
                                    parmaters.settings.client = "default";
                                }
                                break;
                            default:
                                Output_service_1.outPut.success(clc.red("Current allowed storage method fs/s3"));
                                return [2 /*return*/, false];
                                break;
                        }
                        return [4 /*yield*/, this.client.snapshot.createRepository({
                                "repository": option.repository,
                                "body": parmaters
                            })];
                    case 1:
                        resp = _a.sent();
                        resp = this.respFormat(resp);
                        if (resp.acknowledged) {
                            Output_service_1.outPut.success("Repository create successed.");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    EsServiceBase.prototype.deleteRepository = function (option) {
        Output_service_1.outPut.success("Delete Repository '" + option.repository + "' start");
        Output_service_1.outPut.success("waiting...");
        this.client.snapshot.deleteRepository({
            "repository": option.repository,
        }).then(function (resp) {
            Output_service_1.outPut.success("Repository delete successed");
        }).catch(function (error) {
            Output_service_1.outPut.error(error.toString());
        });
    };
    EsServiceBase.prototype.deleteSnapshot = function (option) {
        Output_service_1.outPut.success("Delete Repository '" + option.repository + "' Snapshot '" + option.snapshot + "' start");
        Output_service_1.outPut.success("waiting...");
        this.client.snapshot.delete({
            "repository": option.repository,
            "snapshot": option.snapshot
        }).then(function (resp) {
            Output_service_1.outPut.success("Snapshot delete successed");
        }).catch(function (error) {
            Output_service_1.outPut.error(error.toString());
        });
    };
    EsServiceBase.prototype.createSnapshot = function (option) {
        return __awaiter(this, void 0, void 0, function () {
            var resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.snapshot.create({
                            "repository": option.repository,
                            "snapshot": option.snapshot,
                            "waitForCompletion": option.waitForCompletion,
                            "body": {
                                "indices": option.indices,
                                "ignore_unavailable": true,
                                "include_global_state": false
                            }
                        })];
                    case 1:
                        resp = _a.sent();
                        resp = this.respFormat(resp);
                        if (resp.accepted) {
                            Output_service_1.outPut.success("Snapshot create start.");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    EsServiceBase.prototype.getSnapshotInfo = function (option) {
        return this.client.snapshot.get({
            "repository": option.repository,
            "snapshot": option.snapshot,
            "ignoreUnavailable": true
        }).then(function (resp) {
            // outPut.success(this.respFormat(resp));
            // outPut.success(resp.statusCode);
        });
    };
    EsServiceBase.prototype.setIndicisBySnapshotInfo = function (option) {
        return this.client.snapshot.get({
            "repository": option.repository,
            "snapshot": option.snapshot,
            "ignoreUnavailable": true
        });
    };
    EsServiceBase.prototype.showSnapshotInfo = function (option) {
        var _this = this;
        this.client.snapshot.get({
            "repository": option.repository,
            "snapshot": option.snapshot,
            "ignoreUnavailable": true
        }).then(function (resp) {
            Output_service_1.outPut.success(_this.respFormat(resp));
            // outPut.success(resp.statusCode);
        });
    };
    EsServiceBase.prototype.showSnapshotStatus = function (option) {
        var _this = this;
        var _options = {};
        var show_only_one = false;
        if (option.repository) {
            _options.repository = option.repository;
        }
        if (option.snapshot) {
            _options.snapshot = option.snapshot;
        }
        if (option.repository && option.snapshot) {
            show_only_one = true;
        }
        return this.client.snapshot.status({
            "repository": option.repository,
            "snapshot": option.snapshot,
            "ignoreUnavailable": true
        }).then(function (resp) {
            resp = _this.respFormat(resp);
            if (show_only_one) {
                if (resp.snapshots.length > 0) {
                    var snapshot = resp.snapshots[0];
                    delete snapshot.shards_stats;
                    delete snapshot.stats;
                    var _indices = [];
                    for (var i in snapshot.indices) {
                        _indices.push(i);
                    }
                    snapshot.indices = _indices;
                    if (option.simple_output) {
                        var msg = "";
                        if (snapshot.state == "STARTED") {
                            msg = snapshot.repository + " " + snapshot.snapshot + " IN PROCESS";
                        }
                        else {
                            msg = snapshot.repository + " " + snapshot.snapshot + " " + snapshot.state + " ";
                        }
                        _this.tmp_status = snapshot.state;
                        Output_service_1.outPut.success(msg);
                    }
                    else {
                        Output_service_1.outPut.success("Snapshot status:");
                        Output_service_1.outPut.success(snapshot);
                    }
                }
                else {
                    Output_service_1.outPut.success("Can't find snapshot info.");
                }
            }
            else {
                if (resp.snapshots.length > 0) {
                    Output_service_1.outPut.success("Current running snapshot:");
                    Output_service_1.outPut.table(resp.snapshots);
                }
                else {
                    Output_service_1.outPut.success("No running snapshot.");
                }
            }
        }).catch(function (error) {
            Output_service_1.outPut.error(error.toString());
        });
    };
    EsServiceBase.prototype.showRecoveryWatching = function (option) {
        var _this = this;
        if (!this.pb) {
            this.pb = Output_service_1.outPut.ProgressBar("Total percent", 100);
        }
        option.showPb = true;
        this.showRecovery(option).then(function () {
            if (_this.watch_stop) {
                return false;
            }
            sleep.sleep(1);
            _this.showRecoveryWatching(option);
        });
    };
    EsServiceBase.prototype.showSnapshotStatusWatching = function (option) {
        var _this = this;
        option.simple_output = true;
        this.showSnapshotStatus(option).then(function () {
            if (_this.tmp_status == "STARTED") {
                sleep.sleep(3);
                _this.showSnapshotStatusWatching(option);
            }
        });
    };
    EsServiceBase.prototype.showTaskList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tasks, response, i, node, taskId, task;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tasks = [];
                        return [4 /*yield*/, this.client.tasks.list()];
                    case 1:
                        response = _a.sent();
                        for (i in response.body.nodes) {
                            node = response.body.nodes[i];
                            if (node.tasks) {
                                for (taskId in node.tasks) {
                                    task = node.tasks[taskId];
                                    tasks.push(task);
                                }
                            }
                        }
                        // outPut.success(tasks);
                        return [2 /*return*/, tasks];
                }
            });
        });
    };
    EsServiceBase.prototype.showTaskListSimple = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tasks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.showTaskList()];
                    case 1:
                        tasks = _a.sent();
                        tasks = tasks.filter(function (task) { return !task.parent_task_id; });
                        tasks = tasks.map(function (task) { return task.action; });
                        return [2 /*return*/, tasks];
                }
            });
        });
    };
    EsServiceBase.prototype.showRepository = function () {
        var _this = this;
        this.client.cat.repositories({
            "v": true,
            "s": "id"
        }).then(function (resp) {
            Output_service_1.outPut.success(_this.respFormat(resp));
        });
    };
    EsServiceBase.prototype.showSnapshot = function (option) {
        var _this = this;
        this.client.cat.snapshots({
            "repository": option.repository,
            "v": true,
            "s": "id"
        }).then(function (resp) {
            Output_service_1.outPut.success(_this.respFormat(resp));
        });
    };
    EsServiceBase.prototype.showRecovery = function (option) {
        var _this = this;
        return this.client.indices.recovery({
            "index": option.indices
        }).then(function (resp) {
            resp = _this.respFormat(resp);
            var shards_cnt = 0;
            var percent_cnt = 0;
            var avg_percent = 0;
            for (var i in resp) {
                if (!option.showPb) {
                    Output_service_1.outPut.success("Index:" + i);
                }
                for (var _i = 0, _a = resp[i].shards; _i < _a.length; _i++) {
                    var snapshot = _a[_i];
                    shards_cnt++;
                    percent_cnt += (parseFloat(snapshot.index.size.percent.replace("%", "")));
                    if (!option.showPb) {
                        Output_service_1.outPut.success("Snapshot " + snapshot.id + " " + snapshot.index.size.percent);
                    }
                }
            }
            if (percent_cnt > 0) {
                avg_percent = parseFloat((percent_cnt / shards_cnt).toFixed(2));
            }
            if (option.showPb) {
                _this.pb.render({ completed: avg_percent, total: 100 });
            }
            if (avg_percent >= 100 && option.showPb) {
                Output_service_1.outPut.success('');
                Output_service_1.outPut.success("Restore progress completed!");
                _this.watch_stop = true;
            }
        }).catch(function (error) {
            Output_service_1.outPut.error(error);
        });
    };
    EsServiceBase.prototype.restore = function (option) {
        var _this = this;
        var _option = {
            "repository": option.repository,
            "snapshot": option.snapshot,
            "waitForCompletion": option.waitForCompletion,
            "body": {
                "indices": option.indices,
                "ignore_unavailable": true,
                "include_global_state": false
            }
        };
        if (option.rename_pattern) {
            _option.body.rename_pattern = option.rename_pattern;
        }
        if (option.rename_replacement) {
            _option.body.rename_replacement = option.rename_replacement;
        }
        return this.client.snapshot.restore(_option)
            .then(function (resp) {
            resp = _this.respFormat(resp);
            console.log(resp);
            console.log(_option);
            if (resp.accepted) {
                Output_service_1.outPut.success("Snapshot restore start.");
                return { status: "successed" };
            }
            return { status: "failed" };
        }).catch(function (err) {
            console.log(err);
            // err = this.respFormat(err);
            // if (err) {
            //     outPut.error(err.error.type)
            //     outPut.error(err.error.reason)
            // } else {
            //     outPut.error(err.toString())
            // }
            return { status: "failed" };
        });
    };
    return EsServiceBase;
}());
exports.EsServiceBase = EsServiceBase;
