"use strict";
// ProgressBar tool
Object.defineProperty(exports, "__esModule", { value: true });
var slog = require('single-line-log').stdout;
var ProgressBar = /** @class */ (function () {
    function ProgressBar(description, length) {
        this.description = description || 'Progress';
        this.length = length || 0;
    }
    // progress title
    ProgressBar.prototype.render = function (opts) {
        var percent;
        percent = parseFloat((opts.completed / opts.total).toFixed(4));
        var cell_num = Math.floor(percent * this.length);
        var cell = '';
        for (var i = 0; i < cell_num; i++) {
            cell += '█';
        }
        var empty = '';
        for (var i = 0; i < this.length - cell_num; i++) {
            empty += '░';
        }
        var cmdText = this.description + ': ' + (100 * percent).toFixed(2) + '% ' + cell + empty + ' ' + opts.completed + '/' + opts.total;
        slog(cmdText);
    };
    ;
    return ProgressBar;
}());
exports.ProgressBar = ProgressBar;
