const { Client } = require('@elastic/elasticsearch')
// const logger = require('node-color-log');
const clc = require("cli-color");
try {
    var sleep = require("sleep")
} catch (error) {
    sleep = undefined
}

import { outPut } from "./Output.service";
import { EsServiceBase } from "./EsServiceBase.class"

class EsService extends EsServiceBase {
    public host = process.env.ES_HOST
    public port = process.env.ES_PORT
    public storage_path = process.env.STORAGE_PATH
    public watch_stop = false;
    public client: any
    public tmp_status = ""
    public pb: any

    public temporay_repository: string = ""

    constructor(options: any) {
        super();
        this.init_client(options)
    }
    respFormat(resp: any) {
        return resp
    }

    init_client(options: any) {

        var elasticsearch = require('elasticsearch');
        var AWS = require('aws-sdk');
        var connectionClass = require('http-aws-es');
        AWS.config.update({
            credentials: new AWS.Credentials(options.AWS_AccessKey, options.AWS_SecretKey),
            region: options.AWS_REGION
        });

        this.client = new elasticsearch.Client({
            host: options.ES_HOST,
            connectionClass: connectionClass,
            apiVersion: "6.8",
            amazonES: {
                credentials: new AWS.EnvironmentCredentials('AWS')
            }
        });
    }
}

export { EsService }