// ProgressBar tool

const slog = require('single-line-log').stdout;

class ProgressBar {

    public description: string
    public length: number


    constructor(description: string, length: number) {
        this.description = description || 'Progress';
        this.length = length || 0
    }

    // progress title

    render(opts: { completed: number; total: number; }) {
        let percent: number

        percent = parseFloat((opts.completed / opts.total).toFixed(4));

        let cell_num = Math.floor(percent * this.length);

        var cell = '';
        for (var i = 0; i < cell_num; i++) {
            cell += '█';
        }

        var empty = '';
        for (var i = 0; i < this.length - cell_num; i++) {
            empty += '░';
        }

        var cmdText = this.description + ': ' + (100 * percent).toFixed(2) + '% ' + cell + empty + ' ' + opts.completed + '/' + opts.total;

        slog(cmdText);
    };
}

export { ProgressBar };